
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>计算几何入门向 / 憋错料</title>

    <meta name="description" content="计算几何入门向 这是一个计算几何入门的教程. 与计算几何密切相关的就是坐标系,坐标系上的点可以用下面数据结构实现. struct Point { double x,y; Point(int x,int y) :x(x),y(y){}; };typedef Point Vector; 向量也是经常需要的,由于和点所需储存的信息相同,可以直接定义为别名. 由于需要使用大量加减乘除,我们可以重载运算符达到很好的使用效果. /× 挖坑,有时间再写代码 ×/ 我们也可以用STL的虚数类来实现点和向量. typedef c">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">计算几何入门向</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>这是一个计算几何入门的教程。</p>
<p>与计算几何密切相关的就是坐标系，坐标系上的点可以用下面数据结构实现。</p>
<pre>struct Point
{
	double x,y;
	Point(int x,int y) :x(x),y(y){};
};typedef Point Vector;
</pre>
<p>向量也是经常需要的，由于和点所需储存的信息相同，可以直接定义为别名。</p>
<p>由于需要使用大量加减乘除，我们可以重载运算符达到很好的使用效果。</p>
<p>/&times;</p>
<p>挖坑，有时间再写代码</p>
<p>&times;/</p>
<p>我们也可以用STL的虚数类来实现点和向量。</p>
<pre>typedef complex&lt;double&gt; Point;
typedef Point Vector;

double Dot(Vector A,Vector B)
{
	return real(B*conj(A));
}

double Cross(Vector A,Vector B)
{
	return imag(B*conj(A));
}
</pre>
<p>这样我们就可以直接使用自带的构造函数和重载的运算符，我们只需自己实现点乘和叉乘（同样很简单,设A为a+b i，则Conj（A）=a - b&nbsp; i），可以思考一下为什么是这样写。</p>
<p>这样实现很简单，很好记忆，但效率并不是很高。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-06 07:51:40 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e6%95%88%e6%9e%9c/" title="效果">效果</a>, <a href="https://www.biecuoliao.com/tag/com/" title="&period;com">&period;com</a>, <a href="https://www.biecuoliao.com/tag/%e4%b8%ba%e4%bb%80%e4%b9%88/" title="为什么">为什么</a>, <a href="https://www.biecuoliao.com/tag/%e5%ae%9e%e7%8e%b0/" title="实现">实现</a>, <a href="https://www.biecuoliao.com/tag/turn/" title="turn">turn</a>, <a href="https://www.biecuoliao.com/tag/body/" title="body">body</a>, <a href="https://www.biecuoliao.com/tag/point/" title="point">point</a>, <a href="https://www.biecuoliao.com/tag/%e6%9e%84%e9%80%a0/" title="构造">构造</a>, <a href="https://www.biecuoliao.com/tag/vector/" title="vector">vector</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>计算几何入门向的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xreGr4.html" rel="bookmark">hdu 1086（计算几何入门题&mdash;&mdash;计算线段交点个数）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				链接:http://acm.hdu.edu.cn/showproblem.php?pid=1086 You can Solve a Geometry Problem too Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 7167    Accepted Submission(s): 3480 Problem Description Ma			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzkDkA0.html" rel="bookmark">&lbrack;您有新的未分配科技点&rsqb;计算几何入门（1）：点，向量以及向量的简单应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在打了一阵数据结构之后,老师表示&quot;今天晚上让学长给你们讲一下计算几何&quot;--然后就死了.jpg 昨天晚上一直在推数学的式子以及回顾讲课的笔记--计算几何特点就是多而杂,即使是入门部分也是如此-- 首先,我们从二维的几何问题开始处理. 我们知道,高中解析几何计算几何的基础是向量(Vector)和点(Point),所以我们先来表示这两个概念: 在计算几何中,点和向量一般用结构体来存储,像这样: 1 struct Point 2 { 3 double x,y,rad; 4 Point(doub			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OlZGK4.html" rel="bookmark">计算几何入门模板（持续更新）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我也算是刚入门计算几何吧,想写一篇入门的模板,让那些和我一样刚入门的人都能看懂就好. 首先要有一些理论知识,这可以百度,我就不多说了,通过百度,你要知道: ①叉积可以判断3个点共线,还可以判断2个点构成直线,第3个点在直线的左边还是右边. ②判断两条线段相交要有2个条件,一个是矩形的什么定理(名字太长,忘了)另一个就是4个点的叉积相乘小于0(也就是异号) 之后就可以看下我收集的简单的模板了. #include &lt;map&gt; #include &lt;set&gt; #include &lt;li			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzAdmJ4.html" rel="bookmark">计算几何入门之aizu两题 Projection  Reflection</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				---恢复内容开始--- 使用complex类来写计算几何. 第一题 传送门: 题意给定一直线输入一个点求输入点到该直线射影交点的坐标: = p0到p2向量称为v2,p0到p1向量称为v1 易求得p0到t的向量为 (v2·v1)*(v1的方向向量) . 用复数表示每个点和每个向量,则将v1*(v2的共轭复数)得到的实部就是x1*x2虚部就是y1*y2. 这样求得了p0到t的向量v3,所以ansx=xp0+xv3,ansy=yp0+yv3; 第二题  题意类似,做法相同.不再赘述. 现在贴第二题代			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0doPEBM.html" rel="bookmark">TOYS&lpar;计算几何-入门&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目 '^'代表叉乘 '?'代表点乘 点积:a?b=ax*bx+ay*by 叉积:a^b=ax*by-bx*ay 有了这些,代码就呼之欲出了. 首先read(线段) 然后read(点) 发现满足二分性(点A一定在前t条线后,在后n-t条线前) 于是,二分优化查找 O(mlogn) #include &lt;algorithm&gt; #include &lt;iostream&gt; #include &lt;cstring&gt; #include &lt;cstdlib&gt; #include &l			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6GVXv0.html" rel="bookmark">计算几何入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				poj 3304 #include &lt;iostream&gt; #include &lt;stdio.h&gt; #include &lt;string.h&gt; #include &lt;algorithm&gt; #include &lt;queue&gt; #include &lt;map&gt; #include &lt;vector&gt; #include &lt;set&gt; #include &lt;string&gt; #include &lt;math.h&gt; using			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vBn2j3.html" rel="bookmark">UVA - 11646 - Athletics Track    （计算几何~）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目地址:点这里 思路:计算几何入门题,首先,两个圆弧是同一个圆的,所以这个圆是矩形的外接圆,那么矩形中心就是圆心,由长宽算出角度和半径(这时用单位长度表示),再算出一个单位长度的实际长度,从而得出长和宽 AC代码: #include &lt;cstdio&gt; #include &lt;cstring&gt; #include &lt;algorithm&gt; #include &lt;iostream&gt; #include &lt;cmath&gt; using namespace std;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLykRd0.html" rel="bookmark">计算几何相关</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				任意多边形面积-有向面积 凸包算法(Graham扫描法)详解 蒟蒻blog(计算几何入门) 原文地址:https://www.cnblogs.com/Gkeng/p/12079028.html			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyjYbE0.html" rel="bookmark">【COGS &amp;amp&semi; USACO】896&period; 圈奶牛（凸包）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://cojs.tk/cogs/problem/problem.php?pid=896 我的计算几何入门题... 看了看白书的计算几何部分,,恩好嘛.. 乃们都用向量!!!! 干嘛非要将2个点确定一条线变成一个点从原点o出发的射线!!!! 这就是所谓的玩概念吗 然后用所谓的向量加减,是这些向量起点相同,然后就变成了原点o出发的射线!!! 然后你们还在玩概念!我跪了. (以上纯属蒟蒻吐槽) 好吧,计算几何非常有用的..简化了不少操作. 这里还有啥点积啥叉积.点积就是同一起点的向量(终点)的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMyoWV3.html" rel="bookmark" class="title">关于offsetLeft的取值</a>
					<div>
						ele.offsetLeft的取值,如果ele是body的直接子元素,那么ele.offset的取值就是ele距离body左侧的距离. 但是如果ele不是body的直接子元素,中间还有其他元素,而且中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9496wWM.html" rel="bookmark" class="title">JS基础（超级简单）</a>
					<div>
						1     JS基础(超级简单) 1.1 数据类型 1.1.1   基本类型: 1)        Number:特别注意:NaN的检测方法:Nan!=NaN;或者使用isNaN方法 2)       ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r55rX0.html" rel="bookmark" class="title">2016 系统设计第一期 （档案一）MVC 控制器接收表单数据</a>
					<div>
						1.FormCollection collection   user.UserId =Convert.ToInt32(collection[&quot;UserId&quot;]); /// &lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kDxPP3.html" rel="bookmark" class="title">Oracle日期转换为周，月，季度，半年，年</a>
					<div>
						实现当前时间,周,月,季度,半年,年的转换,其中特别注意的是周的处理,IW方式处理逻辑,如果本周有大于等于4天,本周属于几年,如果小于4天,本周属于下一年 以1990/12/31为例,这天属于1991 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLjEAQ3.html" rel="bookmark" class="title">JavaScript设计模式-8&period;链式调用</a>
					<div>
						1 &lt;!DOCTYPE html&gt; 2 &lt;html&gt; 3 &lt;head&gt; 4 &lt;meta charset=&quot;UTF-8&quot;&gt; 5 &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KqmYJ4.html" rel="bookmark" class="title">CSU 1542 Flipping Parentheses（线段树）</a>
					<div>
						1542: Flipping Parentheses Time Limit: 5 Sec  Memory Limit: 256 MB Submit: 289  Solved: 79 [Submit][ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzQqVq4.html" rel="bookmark" class="title">团队建设</a>
					<div>
						(一)团队建设a.成员:1个leader + 3个Programmerb.定期面谈:7天团队谈(&gt;1小时),3天个人谈(&gt;20分钟). 1.工作进度. 2.学习进步. 3.个人生活. 4. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eyn7a0.html" rel="bookmark" class="title">iDempiere 使用指南 测试 及 开发 虚拟机下载</a>
					<div>
						Created by 蓝色布鲁斯,QQ32876341iDempiere官方中文wiki主页 http://wiki.idempiere.org/zhiDempiere 中文社区www.idempie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6bnrJM.html" rel="bookmark" class="title">mysql索引类型说明</a>
					<div>
						btree和hash Hash 索引结构的特殊性,其检索效率非常高,索引的检索可以一次定位,不像B-Tree 索引需要从根节点到枝节点,最后才能访问到页节点这样多次的IO访问,所以 Hash 索引的查 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mYlY0.html" rel="bookmark" class="title">KeyMob&colon;移动广告优化 帮助开发者提高广告收益</a>
					<div>
						KeyMob是为Android.IOS应用开发者免费提供的移动广告优化的管理平台,目前聚合了多家国内外主流的广告平台,开发者可以在KeyMob后台轻松设置一家或多家适合自己的应用的广告平台,有效提高广 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jnd9W0.html" rel="bookmark" class="title">小峰mybatis（5）mybatis使用注解配置sql映射器--动态sql</a>
					<div>
						一.使用注解配置映射器 动态sql: 用的并不是很多,了解下: Student.java 实体bean: package com.cy.model; public class Student{ pri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXnkeb3.html" rel="bookmark" class="title">保险退保手续费</a>
					<div>
						“保险退保手续费”!非常遗憾,当你搜索这个词的时候,也许遇到了麻烦.这个麻烦可能来自当初购买时,银行或者是保险公司业务员的忽悠,比如他们告诉您:这是一份高收益理财产品.或者说这是买理财赠送的一份保险. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vzJnL3.html" rel="bookmark" class="title">学习IOS开发</a>
					<div>
						在学习IOS开发中第一点要求 ,能比较顺畅的阅读官方的文档,View Programming Guide for iOS  自己阅读,翻译,里面不懂的单词,记下来,多学几遍,这些不懂的单词,在以后你看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/022Pv20.html" rel="bookmark" class="title">C&num;&period;NET 大型企业信息化系统集成快速开发平台 4&period;2 版本 - 外部服务调用、内部服务调用优化，面向服务化的</a>
					<div>
						现在的信息系统越来越复杂,越来越庞大,不仅需要内部是一个整体,而且还需要提供很多对外的服务调用. 1:别人如何调用最方便?用不同的开发语言调用.2:服务的返回状态是什么样子的?有利于排查问题.3:服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35rg5n4.html" rel="bookmark" class="title">Hive学习之数据去重</a>
					<div>
						insert overwrite table store select t.p_key,t.sort_word from ( select p_key, sort_word , row_number( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KvGRmM.html" rel="bookmark" class="title">《CPU的工作过程》</a>
					<div>
						本文转载自inter官方网址:https://software.intel.com/zh-cn/articles/book-Processor-Architecture_CPU_work_proces ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzXOZd3.html" rel="bookmark" class="title">CS0016&colon; 未能写入输出文件的解决方法&lpar;转载&rpar;</a>
					<div>
						转自:http://www.pageadmin.net/article/20130305/537.html IIS7 运行Asp.Net MVC WEB程序出错 错误描述: “/”应用程序中的服务器错 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38rg1RM.html" rel="bookmark" class="title">简述C语言之父的背后</a>
					<div>
						丹尼斯·里奇, C语言之父,UNIX之父. 1978年与布莱恩·科尔尼干(Brian W. Kernighan)一起出版了名著&lt;C程序设计语言(The C Programming Languag ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmQPgKM.html" rel="bookmark" class="title">HTML5初探&mdash;&mdash;新增的表单元素和属性</a>
					<div>
						HTML5初探--新增的表单元素和属性 &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;utf-8&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPBZ9B3.html" rel="bookmark" class="title">iOS添加Prefix Header</a>
					<div>
						1. 添加Prefix Header 注: Xcode 6苹果默认去掉prefix Header, 用以提高原文件的复用性, 便于迁移. 并且可以一定程度上减少Build Time. 解决办法: (1 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
